<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nickname</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Nickname"
              v-model="filter.nickname"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Status</label>

            <b-form-select
              v-model="filter.status"
              :options="formattedStatusOptions"
              size="lg"
            ></b-form-select>
          </div>
        </div>

        <div class="d-flex justify-content-end">
          <button class="btn btn-primary btn-md" @click="filterData">
            <i class="flaticon2-search-1"></i> Filter
          </button>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <complete-table
          :loading="loading"
          :data="this.$store.getters.getterListPenunjang"
        >
          <template #header>
            <tr class="text-left">
              <th style="min-width: 250px" class="pl-7">
                <span class="text-dark-75">Kode Proyek</span>
              </th>
              <th style="min-width: 350px">Nama Proyek</th>
              <th style="min-width: 100px">Nickname</th>
              <th style="min-width: 250px">SOW / DL Scope</th>
              <th style="min-width: 250px">Order Design</th>
              <th style="min-width: 250px">BOM Base</th>
              <th style="min-width: 100px">DL Design</th>
              <th style="min-width: 100px">Submited Man Hour</th>
              <th style="min-width: 100px">Submited Plan Date</th>
              <th style="min-width: 100px">Total Design</th>
              <th style="min-width: 100px">DMP</th>
            </tr>
          </template>

          <template #defaultBody="{ item, i }">
            <tr v-bind:key="i">
              <td class="pl-0 ">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.code }}
                </span>
              </td>

              <td>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.name }}
                </span>
              </td>

              <td>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.nickname }}
                </span>
              </td>

              <td>
                <template v-if="item.sow_file_name">
                  <div class="d-flex">
                    <a
                      class="font-weight-bold d-block align-self-center  mr-3"
                      @click="
                        openFile(
                          item.sow_file_name,
                          item,
                          'order',
                          34,
                          'sow_file_path'
                        )
                      "
                      target="blank"
                    >
                      {{ item.sow_file_name }}
                    </a>
                  </div>
                </template>

                <!--                    <template v-else>-->
                <input
                  :id="'fileUploadSow' + i"
                  @input="uploadFile($event, item, 'sow_file')"
                  type="file"
                  hidden
                />

                <a
                  class="btn btn-light-success font-weight-bolder font-size-sm"
                  @click="uploadSow(i)"
                  :disabled="loadingUpload"
                >
                  Upload <i class="flaticon-upload ml-3"></i>
                </a>
                <!--                    </template>-->
              </td>

              <td>
                <template v-if="item.order_design_file_path">
                  <div class="d-flex">
                    <a
                      class="font-weight-bold d-block align-self-center  mr-3"
                      @click="
                        openFile(
                          item.order_design_file_path,
                          item,
                          'order',
                          76,
                          'order_design_file_path'
                        )
                      "
                      target="blank"
                    >
                      {{ item.order_design_file_name }}
                    </a>
                  </div>
                </template>

                <!--                    <template v-else>-->
                <input
                  :id="'fileUploadOrder' + i"
                  @change="uploadFile($event, item, 'order_file')"
                  type="file"
                  hidden
                />

                <a
                  class="btn btn-light-success font-weight-bolder font-size-sm"
                  @click="uploadOrder(i)"
                  :disabled="loadingUpload"
                >
                  Upload <i class="flaticon-upload ml-3"></i>
                </a>
                <!--                    </template>-->
              </td>

              <td>
                <template v-if="item.bom_base_file_path">
                  <div class="d-flex">
                    <a
                      class="font-weight-bold d-block align-self-center mr-3 text-primary"
                      @click="
                        openFile(
                          item.bom_base_file_name,
                          item,
                          'bom',
                          76,
                          'bom_base_file_path'
                        )
                      "
                      target="blank"
                    >
                      {{ item.bom_base_file_name }}
                    </a>
                  </div>
                </template>

                <!--                    <template v-else>-->
                <input
                  :id="'fileUploadBom' + i"
                  @change="uploadFile($event, item, 'bom_file')"
                  type="file"
                  hidden
                />

                <a
                  class="btn btn-light-success font-weight-bolder font-size-sm"
                  @click="uploadBom(i)"
                  :disabled="loadingUpload"
                >
                  Upload <i class="flaticon-upload ml-3"></i>
                </a>
                <!--                    </template>-->
              </td>

              <td>
                <span class="text-muted font-weight-bold d-block">
                  <a href="">
                    DL Design
                  </a>
                </span>
              </td>

              <td>
                <a
                  class="font-weight-bold d-block"
                  href="#"
                  @click="showSubmitedManHourModal(item)"
                >
                  {{ item.submited_man_hour }}
                </a>
              </td>

              <td>
                <a
                  class="font-weight-bold d-block"
                  href="#"
                  @click="showSubmitedManHourModal(item)"
                >
                  {{ item.submited_plan_date }}
                </a>
              </td>

              <td>
                <a
                  class="font-weight-bold d-block"
                  href="#"
                  @click="showSubmitedManHourModal(item)"
                >
                  {{ item.total_design }}
                </a>
              </td>

              <td>
                <span class="text-muted font-weight-bold d-block">
                  {{ item.revision_dmp }}
                </span>
              </td>
            </tr>
          </template>
        </complete-table>
      </div>
    </div>

    <b-modal
      ref="detail-man-hour"
      hide-footer
      title="Detail Man Hour & Plan date"
    >
      <div class="d-block text-center">
        <div class="table-responsive">
          <table
            class="table table-head-custom table-vertical-center table-head-bg table-borderless"
          >
            <thead>
              <tr class="text-left">
                <th style="min-width: 100px" class="pl-7">
                  <span class="text-dark-75">Scope</span>
                </th>
                <th style="min-width: 100px">Submited Man Hour</th>
                <th style="min-width: 100px">Submited Plan Date</th>
                <th style="min-width: 100px">Total Design</th>
              </tr>
            </thead>

            <tbody>
              <template
                v-for="(item, i) in selectedProject
                  ? selectedProject.submited_man_hours
                  : []"
              >
                <tr v-bind:key="i">
                  <td class="pl-0 ">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.scope }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.submited_man_hour }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.submited_plan_date }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.total_design }}
                    </span>
                  </td>
                </tr>
              </template>
            </tbody>
          </table>
        </div>
      </div>
    </b-modal>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { GET_CHECKLIST_PENUNJANG } from "@/core/services/store/document-penunjang.module";
import {
  POST_DOCUMENT_FORM,
  UPDATE_DOCUMENT_FORM
} from "../../../core/services/store/document-penunjang.module";
import { mapState } from "vuex";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";
import { GET_STATUS_OPTION } from "../../../core/services/store/status.module";
import { arrayMoreThanOne } from "../../../core/helper/array-validation.helper";

export default {
  name: "CheckListDocument",
  components: { CompleteTable },
  data() {
    return {
      filter: {
        status: null,
        name: null,
        code: null,
        owner: null,
        contractNumber: null,
        nickname: null
      },
      options: {
        statuses: [
          { value: null, text: "Pilih Status" },
          { value: "open", text: "Open" },
          { value: "close", text: "Close" }
        ]
      },
      selectedProject: null,
      sow_link: "https://www.google.com/",
      data: {
        projects: [
          {
            code: "LR98123",
            name: "PEMBANGUNAN SISTEM PERSINYALAN",
            nickname: "MAKPAR 1",
            sow_link: "https://www.google.com/",
            order_design_link: null,
            bom_base_link: null,
            dl_design: "DL Design",
            submited_man_hour: "40",
            submited_plan_date: "50",
            total_design: "100",
            dmp: "Rev 1",
            submited_man_hours: [
              {
                scope: "HMI",
                submited_man_hour: "40",
                submited_plan_date: "20",
                total_design: "80"
              },
              {
                scope: "Circuit",
                submited_man_hour: "40",
                submited_plan_date: "20",
                total_design: "80"
              },
              {
                scope: "Signal",
                submited_man_hour: "40",
                submited_plan_date: "20",
                total_design: "80"
              }
            ]
          }
        ]
      }
    };
  },
  computed: {
    ...mapState({
      loadingUpload: state => state.dokumenPenunjang.loadingUpload,
      loading: state => state.dokumenPenunjang.loading,
      statuses: state => state.status.status?.data
    }),

    formattedStatusOptions() {
      let status = [];

      if (arrayMoreThanOne(this.statuses)) {
        status = this.statuses.map(scope => {
          return {
            value: scope.code,
            text: scope.name
          };
        });
      }

      return [{ value: null, text: "Pilih Status" }, ...status];
    }
  },
  methods: {
    uploadBom(i) {
      document.getElementById("fileUploadBom" + i).click();
    },

    uploadSow(i) {
      document.getElementById("fileUploadSow" + i).click();
    },

    uploadOrder(i) {
      document.getElementById("fileUploadOrder" + i).click();
    },

    uploadFile(value, item, type) {
      const file = value.target.files[0];

      const keys = ['sow_file', 'bom_file', 'order_file'];

      let form = new FormData();

      keys.forEach(key => {
        form.append(
          key,
          type === key 
            ? file 
            : null 
        );
      });

      form.append('code_project', item?.code);

      this.$store.dispatch(UPDATE_DOCUMENT_FORM, form);
    },

    deleteFile(index, key) {
      this.data.projects[index][key] = null;
    },

    showSubmitedManHourModal(selectedProject) {
      this.selectedProject = selectedProject;

      this.$refs["detail-man-hour"].show();
    },

    openFile(fileName, item, type, folderId, key) {
      this.$store
        .dispatch(POST_DOCUMENT_FORM, {
          project_code: item?.code,
          server_type: "DEV",
          folder_id: folderId,
          filename: fileName
        })
        .then(response => {
          Promise.resolve();

          const data = response.data.data;

          window.location.href = `ftp://${data.ftp.username}:${data.ftp.password}@${data.ftp.server}${item[key]}`;
        });
    },

    closeSubmitedManHourModal() {
      this.selectedProject = null;

      this.$refs["detail-man-hour"].hide();
    },

    search() {
      const nickname = this.filter.nickname;

      let newNick = "";

      if (nickname != null) {
        newNick = nickname.toLowerCase();
      } else {
        newNick = null;
      }

      const result = this.$store.getters.getterMasterPenunjang;

      result.filter(res => res.nickname.toLowerCase().includes(newNick));
    },

    filterData() {
      this.$store.dispatch(GET_CHECKLIST_PENUNJANG, {
        jobdesk: "design",
        ...this.filter
      });
    }
  },
  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [
      { title: "Checklist Dokumen Penunjang" }
    ]);

    this.$store.dispatch(GET_CHECKLIST_PENUNJANG, { jobdesk: "design" });

    this.$store.dispatch(GET_STATUS_OPTION);
  }
};
</script>

<style></style>
